--- tc.c	2007-08-21 08:43:15.000000000 +0200
+++ tc.c	2007-10-17 09:41:36.000000000 +0200
@@ -102,12 +102,14 @@
 	{
 		// get (htb) data for any customer with connected nodes and active assignments
 		// we need customer ID and average data values for nodes
+   // insert
 		ures = g->db_query(g->conn, "\
 			SELECT customerid AS id, \
 				SUM(uprate)/COUNT(DISTINCT nodes.id) AS uprate, \
 				SUM(downrate)/COUNT(DISTINCT nodes.id) AS downrate, \
 				SUM(upceil)/COUNT(DISTINCT nodes.id) AS upceil, \
 				SUM(downceil)/COUNT(DISTINCT nodes.id) AS downceil, \
+				SUM(downceil)*5/4/COUNT(DISTINCT nodes.id) AS downburst, \
 				SUM(climit)/COUNT(DISTINCT nodes.id) AS climit, \
 				SUM(plimit)/COUNT(DISTINCT nodes.id) AS plimit \
 			FROM assignments \
@@ -144,10 +146,14 @@
 					char *downrate = g->db_get_data(ures,i,"downrate");
 					char *upceil = g->db_get_data(ures,i,"upceil");
 					char *downceil = g->db_get_data(ures,i,"downceil");
+			// insert	
+					char *downburst = g->db_get_data(ures,i,"downburst");
 					char *climit = g->db_get_data(ures,i,"climit");
 					char *plimit = g->db_get_data(ures,i,"plimit");
 					int n_upceil = atoi(upceil);					
 					int n_downceil = atoi(downceil);					
+			// insert	
+					int n_downburst = atoi(downburst);					
 					int n_uprate = atoi(uprate);					
 					int n_downrate = atoi(downrate);					
 					int n_climit = atoi(climit);
@@ -176,6 +182,8 @@
 						int h_upceil = (int) n_upceil/nres->nrows;
 						int h_downrate = (int) n_downrate/nres->nrows;
 						int h_downceil = (int) n_downceil/nres->nrows;  
+				// insert
+						int h_downburst = (int) n_downburst/nres->nrows;  
 						int h_plimit = (int) n_plimit/nres->nrows;
 						int h_climit = (int) n_climit/nres->nrows;  
 						
@@ -188,8 +196,8 @@
 						if(!nc || v!=nc)
 						{
 							got_node = 1;
-						
-							if(h_uprate && h_downrate)
+				// change						
+							if(h_uprate && h_downrate && h_downburst)
 							{
 								g->str_replace(&mark_up, "%n", name);
 								g->str_replace(&mark_up, "%i", ipaddr);
@@ -205,6 +213,7 @@
 					
 								if(tc->one_class_per_host)
 								{
+					// insert
 									g->str_replace(&htb_up, "%n", name);
 									g->str_replace(&htb_up, "%i", ipaddr);
 									g->str_replace(&htb_up, "%m", mac);
@@ -220,6 +229,8 @@
 									g->str_replace(&htb_down, "%m", mac);
 									g->str_replace(&htb_down, "%x", itoa(x));
 									g->str_replace(&htb_down, "%downrate", itoa(h_downrate));
+					// insert
+									g->str_replace(&htb_down, "%downburst", itoa(h_downburst));
 									if(!h_downceil)
 										g->str_replace(&htb_down, "%downceil", itoa(h_downrate));
 									else						
@@ -253,8 +264,8 @@
 					
 							if(tc->one_class_per_host) x++;
 						}
-						
-						if(!tc->one_class_per_host && j==g->db_nrows(nres)-1 && got_node && n_downrate && n_uprate)
+			// change						
+						if(!tc->one_class_per_host && j==g->db_nrows(nres)-1 && got_node && n_downrate && n_uprate && n_downburst)
 						{
 							g->str_replace(&htb_up, "%n", name);
 							g->str_replace(&htb_up, "%x", itoa(x));
@@ -266,6 +277,8 @@
 							g->str_replace(&htb_down, "%n", name);
 							g->str_replace(&htb_down, "%x", itoa(x));
 							g->str_replace(&htb_down, "%downrate", downrate);
+			// insert
+							g->str_replace(&htb_down, "%downburst", downburst);
 							if(!n_downceil)
 								g->str_replace(&htb_down, "%downceil", downrate);
 							else						
